#include <algorithm>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <sstream>
#include <map>
#include <set>
#include <queue>
#include <vector>

using namespace std;

typedef long long int ll;
typedef pair<int, int> pii;

#define PB push_back
#define MP make_pair

#define FOR(prom, a, b) for(int prom = (a); prom < (b); prom++)
#define FORD(prom, a, b) for(int prom = (a); prom > (b); prom--)
#define FORDE(prom, a, b) for(int prom = (a); prom >= (b); prom--)
#define R1(a) do{scanf("%d", &(a));}while(0)
#define R2(a, b) do{scanf("%d%d", &(a), &(b));}while(0)
#define R3(a, b, c) do{scanf("%d%d%d", &(a), &(b), &(c));}while(0)
#define SV(vec) do{int s_v_;scanf("%d", &(s_v_));vec.PB(s_v_);}while(0)
#define MM(co, cim) memset((co), (cim), sizeof((co)))
#define DEB(x) cerr << ">>> " << #x << " : " << x << endl;
#define INF 100000007

struct edge
{
  int from, to, resid, origr, antip, isresid;
};

int n, m, from, to, res;
vector<int> g[2014];

#define SRC 4010
#define SNK 4011
vector<pair<int, int> > flowg[4014];
int p[4014], pe[4014], u[4014], od[4014], id[4014];
vector<edge> e;

void add_edge (int from, int to, int cap)
{
  flowg[from].PB(MP(to, e.size()));
  edge x;
  x.from = from;
  x.to = to;
  x.resid = x.origr = cap;
  x.antip = e.size() + 1;
  x.isresid = 0;
  e.PB(x);
  flowg[to].PB(MP(from, e.size()));
  x.from = to;
  x.to = from;
  x.resid = x.origr = 0;
  x.antip = e.size() - 1;
  x.isresid = 1;
  e.PB(x);
}

int find_path (int x, int rc)
{
  u[x] = 1;
  if (x == SNK) return rc;
  FOR(i, 0, (int)flowg[x].size())
  {
    if (!u[flowg[x][i].first] && e[flowg[x][i].second].resid)
    {
      int nrc = min(rc, e[flowg[x][i].second].resid);
      p[flowg[x][i].first] = x;
      pe[flowg[x][i].first] = flowg[x][i].second;
      int ret = find_path(flowg[x][i].first, nrc);
      if (ret) return ret;
    }
  }
  return 0;
}

int max_flow_ff (void)
{
  int rc, res = 0;
  while (1)
  {
    FOR(i, 0, 4014) 
    {
      p[i] = pe[i] = -1;
      u[i] = 0;
    }
    rc = find_path(SRC, INF);
    if (!rc) break;
    int cx = SNK;
    while (p[cx] != -1)
    {
      e[pe[cx]].resid -= rc;
      e[e[pe[cx]].antip].resid += rc;
      cx = p[cx];
    }
    res += rc;
  }
  return res;
}

int main ()
{
  R2(n, m);
  FOR(i, 0, m)
  {
    R2(from, to);
    --from;
    --to;
    g[from].PB(to);
  }
  
  //hrany zdroj->vrchol, vrchol->stok
  FOR(i, 0, n)
  {
    add_edge(SRC, i, 1);
    add_edge(n + i, SNK, 1);
  }
  //hrany mezi vrcholy
  FOR(i, 0, n) FOR(j, 0, (int)g[i].size())
  {
    add_edge(i, n + g[i][j], 1);
  }
  res = max_flow_ff();
  MM(id, 0);
  MM(od, 0);
  FOR(i, 0, (int)e.size()) if (!e[i].isresid && e[i].from != SRC && e[i].to != SNK)
  {
    int fls = e[i].origr - e[i].resid;
    if (fls) 
    {
      ++od[e[i].from];
      ++id[e[i].to];
      //printf("Pairing has edge (%d, %d)\n", e[i].from + 1, e[i].to - n + 1);
    }
  }
  FOR(i, 0, (int)e.size()) if (!e[i].isresid && e[i].from != SRC && e[i].to != SNK)
  {
    int fls = e[i].origr - e[i].resid;
    if (!fls && (!od[e[i].from] || !id[e[i].to])) 
    {
      e[i].origr = 1;
      e[i].resid = 0;
      ++od[e[i].from];
      ++id[e[i].to];
      //printf("Adding edge back to graph (%d, %d)\n", e[i].from + 1, e[i].to - n + 1);
      ++res;
    }
  }
  
  printf("%d\n", m - res);
  return 0;
}
