#include <iostream>
#include <vector>
#include <cassert>
using namespace std;
typedef long long int ll;

typedef vector<vector<ll>> graph;

ll N,M;
graph g;
vector<ll> seen, matching;

bool bpm(ll u,ll origin,ll depth=0) {
    for(ll v:g[u]){
        if(seen[v] != origin) {
            seen[v] = origin;
            ll mv=v-N;
            if(matching[mv] == -1 || bpm(matching[mv],origin,depth+2)) {
                matching[mv] = u;
                return true;
            }
        }
    }
    return false;
}

ll maxBPM() {
    matching=vector<ll>(N,-1);
    seen=vector<ll>(2*N,-1);
    ll result = 0;
    for(ll u=0; u<N; ++u) if(bpm(u,u)) ++result;
    return result;
}

int main() {
    cin>>N>>M;
    assert(1 <= N && N <= 2000);
    assert(0 <= M && M <= 5000);
    g=graph(2*N);
    for(ll i=0; i<M; ++i){
        ll a,b;cin>>a>>b;
        assert(a!=b);
        --a;--b;b+=N;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    ll base=2*N-2;
    ll match=maxBPM();
    //for(ll i=0;i<matching.size(); ++i){
        //cout<<i<<" -> "<<matching[i]<<endl;
    //}
    ll need=base-match;
    ll remove=M-need;
    //cout<<base<<' '<<match<<' '<<need<<' '<<remove<<endl;
    cout << remove << endl;
    return 0;
}

